/* ansi...some escape routine sequences automated for C on systems with
   device=ansi.sys in config.sys.  this is for MS/PC dos environments
   only.  to activate them...set isansiok to nonzero, here or elsewhere
   (it's a global).  some routines will also allow bios-screen calls
   if isbiosok is set to nonzero.

   This was compiled under MIX software's POWER C compiler without
   incident.

   If you use this software, enjoy it.  Please, however, give me credit
   where credit is due.  These routine as copyright (c) 1990 by
   Richard F. Parker, as part of a promotion for Thunderhead Software, Inc.
*/

#include <stdio.h>
#include <stdlib.h>
#include <bios.h>

int isansiok = 0, isbiosok = 0;


void scls()   /* Clear the Screen */
{
    if( isansiok != 0 ) {
        putc( 27, stdout ); putc( 91, stdout);
        putc( 50, stdout ); putc( 74, stdout);
        fflush(stdout);
    }
    else if( isbiosok != 0 ) {
        clrscrn();
    }
}


void sloc( x1, y1 )     /* Relocate the Cursor */
int x1, y1;
{
    if( isansiok != 0 ) {
        printf("%c[%d;%dH", 27, x1, y1 );
        fflush(stdout);
    }

}


void sscs( a, f, b )    /* Select Color Scheme */
int a, f, b;
{
    if( isansiok != 0 ) {
        if( a > 0 && a < 7 ) {
             putc( 27, stdout );
             putc( 91, stdout );
             switch(a) {
                  case 1: putc( 48, stdout);        /* reset */
                       break;
                  case 2: putc( 49, stdout);        /* highlight */
                       break;
                  case 3: putc( 52, stdout);
                       break;
                  case 4: putc( 53, stdout);
                       break;
                  case 5: putc( 55, stdout);
                       break;
                  case 6: putc( 56, stdout);
                       break;
             }
             putc( 109, stdout );
        }
        if( f > 0 && f < 9 ) printf("%c[%dm", 27, f + 29 );
        if( b > 0 && b < 9 ) printf("%c[%dm", 27, b + 39 );
        fflush(stdout);
    }
}


